#!/usr/bin/python -i

from PyQt4 import QtCore, QtGui

class GraphicsView(QtGui.QGraphicsView):
  def __init__(self, *args):
    QtGui.QGraphicsView.__init__(self, *args)
    self.setVerticalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOff)
    self.setHorizontalScrollBarPolicy(QtCore.Qt.ScrollBarAlwaysOff)
    self.setTransformationAnchor(QtGui.QGraphicsView.NoAnchor)
    self.setSceneRect(QtCore.QRectF(-1e100, -1e100, 1e100, 1e100))
    m = self.matrix()
    m.translate(-200, -200)
    self.setMatrix(m)

  def mouseDoubleClickEvent(self, ev):
    pass
    
  def mousePressEvent(self, ev):
    if ev.buttons() == QtCore.Qt.LeftButton:
      QtGui.QGraphicsView.mousePressEvent(self, ev)
    self.mouse = [ev.pos().x(), ev.pos().y()]
        
  def mouseReleaseEvent(self, ev):
    if ev.button() == QtCore.Qt.LeftButton:
      QtGui.QGraphicsView.mouseReleaseEvent(self, ev)

  def mouseMoveEvent(self, ev):
    if ev.buttons() == QtCore.Qt.LeftButton:
      QtGui.QGraphicsView.mouseMoveEvent(self, ev)
    if ev.buttons() in [QtCore.Qt.RightButton, QtCore.Qt.LeftButton]:
      m = self.matrix()
      m.translate(ev.pos().x()-self.mouse[0], ev.pos().y()-self.mouse[1])
      self.setMatrix(m)
    self.mouse = [ev.pos().x(), ev.pos().y()]



app = QtGui.QApplication([])
mw = QtGui.QMainWindow()
gv = GraphicsView(mw)
sc = QtGui.QGraphicsScene()
gv.setScene(sc)
for i in range(0, 100, 10):
  for j in range(0, 100, 10):
    sc.addEllipse(-50+i, -50+j, 50, 50)
mw.setCentralWidget(gv)
mw.show()